function [y] = spectrogram(x)

window_size = 4096 ;
win_step = 512 ;

sz = size(x) ;
sz = sz(1) ;

ft = ones(floor((sz-window_size)/win_step), window_size) ;

max = size(x) ;
max =  ((max(1) - window_size) / win_step) ;

for cnt = 1:max

    win_start = (cnt-1) * win_step + 1 ;

%    win = window(@gausswin, window_size) ;

%    d = x(win_start:win_start+window_size-1) .* win ;
    d = x(win_start:win_start+window_size-1) ;

    ft(cnt,:) = (fft(d))' ;

end ;

ft = log(ft) ;


colormap(gray) ;
imagesc(abs(ft(:,1:250)')) ;

