[sdata, fs, nb] = wavread('Data\Tony\ton5.wav'); 

% params
window = hann(1024);
overlap = 0.5;
log = 'log';
doplot = true;

spec = spectrogramm(sdata, fs, window, overlap, log, doplot);

%filter and dominant
cutfreq = 80;
fftsize = 1024;

specf = abs(spec);

for i = 1:size(spec, 2)
    % get window
    window = specf(:, i);
    % filter one window
    indexcut = 1 + floor(cutfreq * fftsize / fs);
    for j = indexcut:-1:1
        if j == indexcut
            f1 = fs / fftsize;
            fj = fs * j / fftsize;
            window(j) = window(j) * (fj - cutfreq) / f1;
        else
            window(j) = 0;
        end
    end
    specf(:, i) = window;
end
    
pcp = pcpfeatures(specf, 12, fs, doplot); %specf(1:512, :)

ind = [];
for i = 1:size(pcp, 2)
    p = pcp(:, i);
    p(8) = 0;
    
    m = max(p');
    f = find(p == m);
    ind = [ind f];
end

u = unique(ind); maxval = -1; win = -1;
for i = 1:length(u)
    f = find(ind == u(i));
    
    if (length(f) > maxval)
        maxval = length(f);
        win = u(i);
    end
end